// Modul...: VIDEO_PAL MAIN.C
// Version.: 1.0
// Compiler: Keil-ARM
// Datum...: Dezember 2005
// Autor...: Udo Jrss / Ulrich Radig
//------------------------------------------------------------------------------

#include "typedefs.h"
#include "ssp_master.h"
#include "pal.h"
//-----------------------------------------------------------------------------

void main(void)
{
  U32 c,x,y,n;

  sys_init(); // System initialisieren

  uart0_init(UART_BAUDRATE_38K4); // UART0 initialisieren
  uart0_writeln_str(FIRMWARE_VERSION);
  pal_init(); // PAL initialisieren

  ssp_master_init(DSS_16_BIT); // SSP-Schnittstelle initialisieren


  pal_encode_str(5,0,"VideoGen by Udo Juerss / Ulrich Radig");

  for (n = 0; n < PAL_CHAR_ROWS; n++)
  {
    pal_encode_str(2,n,sup_U08_to_str(n,2));
  }

  x = 7;
  y = 7;
  n = 0;

  for (c = 32; c < FONT_7X9_CHARS + 32; c++)
  {
    pal_encode_char(x++,y,c);
    n++;

    if (n % 10 == 0)
    {
      y++;
      x = 7;
      n = 0;
    }
  }
  
  for (n = 40; n < 200; n++)
  {
  	set_pixel (n,n);
  }

  while(1)
  {
  }
}
