#ifndef __PAL_H
#define __PAL_H
//-----------------------------------------------------------------------------

#include "lpc213x.h"
#include "typedefs.h"
#include "system.h"
#include "timer0_sleep_ni.h"
#include "font_7x9.h"
#include "ssp_master.h"
//-----------------------------------------------------------------------------

#define PAL_MAX_LINES (U32)312 // Standard PAL Zeilen pro Halbbild
#define PAL_VERT_OFF (U32)32
#define PAL_CHAR_COLS (U32)46
#define PAL_CHAR_ROWS (U32)26
#define PAL_CHAR_LINES (U32)10
#define PAL_CHAR_BLANK_LINES (U32)0
#define PAL_TOTAL_CHAR_LINES (U32)(PAL_CHAR_LINES + PAL_CHAR_BLANK_LINES)
#define PAL_BYTES_PER_CHAR_ROW (U32)(PAL_CHAR_LINES * PAL_CHAR_COLS)

#define PAL_TIMER_CLK (U32)5000000 // 200ns Timer1-Takt
#define PAL_HSYNC_64_US (U32)320 // Timer Ticks fr 64.0s HSync Intervall
#define PAL_HSYNC_32_US (U32)160 // Timer Ticks fr 32.0s HSync Intervall
#define PAL_POST_HSYNC (U32)20 // Start der Zeichenausgabe nach HSync [s]
#define PAL_HSYNC_DURATION (U32)20 // Timer Ticks fr 4.8s HSync Pulsbreite
#define PAL_HALF_HSYNC_DURATION (U32)(PAL_HSYNC_DURATION / 2) // Timer Ticks fr 2.4s HSync Pulsbreite

#define PAL_SYNC_DIR IODIR0 // Datenrichtungsregister fr Sync-Signal
#define PAL_SYNC_SET IOSET0 // Setzregister fr Sync-Signal
#define PAL_SYNC_CLR IOCLR0 // Lschregister fr Sync-Signal
#define PAL_SYNC_PIN P0_21 // Pin fr Sync-Signal

// Makros
#define PAL_SYNC_INIT() (PAL_SYNC_DIR |= PAL_SYNC_PIN)
#define PAL_SYNC_HIGH() (PAL_SYNC_SET = PAL_SYNC_PIN)
#define PAL_SYNC_LOW() (PAL_SYNC_CLR = PAL_SYNC_PIN)
//-----------------------------------------------------------------------------

void pal_init(void);
void pal_encode_char(U32 col,U32 row,U08 chr);
void pal_encode_str(U32 col,U32 row,pU08 pstr);
void set_pixel (U32 zeile,U32 spalte);
void clear_pixel (U32 zeile,U32 spalte);
//-----------------------------------------------------------------------------

#endif
